package cn.ibizlab.businesscentral.core.base.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.base.domain.Organization;
import cn.ibizlab.businesscentral.core.base.filter.OrganizationSearchContext;
import cn.ibizlab.businesscentral.core.base.service.IOrganizationService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.businesscentral.core.base.mapper.OrganizationMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[组织] 服务对象接口实现
 */
@Slf4j
@Service("OrganizationServiceImpl")
public class OrganizationServiceImpl extends ServiceImpl<OrganizationMapper, Organization> implements IOrganizationService {

    @Autowired
    @Lazy
    private cn.ibizlab.businesscentral.core.service.service.IResourceService resourceService;
    @Autowired
    @Lazy
    private cn.ibizlab.businesscentral.core.base.service.ITemplateService templateService;
    @Autowired
    @Lazy
    private cn.ibizlab.businesscentral.core.base.service.ITransactionCurrencyService transactioncurrencyService;

    private int batchSize = 500;

    @Override
    @Transactional
    public Organization get(String key) {
        Organization et = getById(key);
        if(et==null){
            et=new Organization();
            et.setOrganizationid(key);
        }
        else{
        }
        return et;
    }

    @Override
    @Transactional
    public boolean create(Organization et) {
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getOrganizationid()),et);
        return true;
    }

    @Override
    public void createBatch(List<Organization> list) {
        this.saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean save(Organization et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional(
            rollbackFor = {Exception.class}
    )
    public boolean saveOrUpdate(Organization et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public boolean saveBatch(Collection<Organization> list) {
        saveOrUpdateBatch(list,batchSize);
        return true;
    }

    @Override
    public void saveBatch(List<Organization> list) {
        saveOrUpdateBatch(list,batchSize);
    }

    @Override
    public Organization getDraft(Organization et) {
        return et;
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    public boolean checkKey(Organization et) {
        return (!ObjectUtils.isEmpty(et.getOrganizationid()))&&(!Objects.isNull(this.getById(et.getOrganizationid())));
    }
    @Override
    @Transactional
    public boolean update(Organization et) {
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("organizationid",et.getOrganizationid())))
            return false;
        CachedBeanCopier.copy(get(et.getOrganizationid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<Organization> list) {
        updateBatchById(list,batchSize);
    }


	@Override
    public List<Organization> selectByAcknowledgementtemplateid(String templateid) {
        return baseMapper.selectByAcknowledgementtemplateid(templateid);
    }

    @Override
    public void removeByAcknowledgementtemplateid(String templateid) {
        this.remove(new QueryWrapper<Organization>().eq("acknowledgementtemplateid",templateid));
    }

	@Override
    public List<Organization> selectByBasecurrencyid(String transactioncurrencyid) {
        return baseMapper.selectByBasecurrencyid(transactioncurrencyid);
    }

    @Override
    public void removeByBasecurrencyid(String transactioncurrencyid) {
        this.remove(new QueryWrapper<Organization>().eq("basecurrencyid",transactioncurrencyid));
    }


    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<Organization> searchDefault(OrganizationSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<Organization> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<Organization>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }







    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<Organization> getOrganizationByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<Organization> getOrganizationByEntities(List<Organization> entities) {
        List ids =new ArrayList();
        for(Organization entity : entities){
            Serializable id=entity.getOrganizationid();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0)
           return this.listByIds(ids);
        else
           return entities;
    }

}



